﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.8
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	
	Dim nativeMe As JavaObject

End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize
	
	nativeMe = Me
	
End Sub


Public Sub generateFractal(wdth As Double, hght As Double, isColor As Boolean) As Int()

	Dim coldata() As Int = nativeMe.RunMethod("draw", Array(wdth.As(Int), hght.As(Int),isColor))
	Return coldata
	
End Sub

public Sub setExp (exp As Int)
	
	nativeMe.RunMethod("setExp", Array(exp))
	
End Sub


#if Java

import fractals.math.ComplexNumber;
import java.io.IOException;
import java.io.BufferedReader;
import java.io.File;
import java.io.InputStreamReader;
import javax.imageio.ImageIO;
import java.awt.Color;
import java.awt.image.BufferedImage;
import fractals.util.MiscUtils;
import static java.lang.System.out;


  private final int MAX_ITERATIONS = 32;
  private final double EPSILON = 0.000001;
  
  public int exp = 0;
  public void setExp (int exp1) {
  	exp = exp1;
  }

  private boolean isRoot(ComplexNumber z) {
    z = ComplexNumber.pow(z,exp);
    z.subtract(new ComplexNumber(1,0));
    return Math.abs(z.mod()) < EPSILON;
  }
  
  public int[] draw(int width, int height, boolean isColor) {
  	
    double WIDTH = 0;
    double HEIGHT = 0;
    WIDTH = width;
    HEIGHT = height;
	int[] coldata = new int[(int)WIDTH * (int)HEIGHT];
    float hue = 0f;
    float saturation = 1f;
    float brightness = 0.95f;

	int cnt = 0;
    for(int X=0; X<WIDTH; X++) {
      for(int Y=0; Y<HEIGHT; Y++) {
        // Scaling to [-2.5,2.5]
        ComplexNumber a = new ComplexNumber((X-WIDTH/2)/(WIDTH/5), (Y-HEIGHT/2)/(HEIGHT/5));
        int iteration = 0;
        for(; iteration<MAX_ITERATIONS; iteration++) {
          // Calculating f(x)
          ComplexNumber f = ComplexNumber.pow(a,exp);
          f.subtract(new ComplexNumber(1,0));
          // Calculating f'(x)
          ComplexNumber df = ComplexNumber.pow(a,exp-1);
          df.multiply(new ComplexNumber(exp,0));
          // a-f(a)/f'(a)
          a.subtract(ComplexNumber.divide(f,df));
          if(isRoot(a))
            break;
        }
        // Mapping no. of iterations to hue
        hue = (float)iteration/MAX_ITERATIONS;
		if (isColor == true) {
			coldata[cnt] = Color.getHSBColor(hue, saturation, brightness).getRGB();
		}
		if (isColor == false) {
			int shade = (int)(((float)iteration/MAX_ITERATIONS)*255);
	        coldata[cnt] = new Color(shade, shade, shade).getRGB();		
		}	
		cnt = cnt + 1;
		
      }
    }
	return coldata;
  }
  

#End If
